;************************************************************************
;*									*
;*			Using Maxim 1-Wire Temperature Sensors		*
;*									*
;*		Author: P. Dannegger					*
;*			danni@specs.de					*
;*									*
;************************************************************************
.nolist
.include "1wire.h"
.include "lcd.mac"
.list
.listmac
	rjmp	init
;-------------------------------------------------------------------------
	.org	ovf0addr
.include "ovf0int.inc"
;-------------------------------------------------------------------------
init:	ldi	zl, low( 2 * calbyte )
	ldi	zh, high( 2 * calbyte )
	lpm					;read calibration from Flash
	out	osccal, r0

	sbi	key_out, key_pin		;activate pull up

	ldi	a0, 1<<CS01^1<<CS00
	out	TCCR0, a0			;prescaler 1/64
	ldi	a0, 1<<TOIE0
	out	TIMSK, a0			;enable timer interrupt
	ldi	meas_delay, 1

	rcall	lcd_init

	sei
;-------------------------------------------------------------------------
main:	sbrs	key_reg, key_press
	rjmp	_mai1
	cbr	key_reg, 1<<key_press
	ldi	a0, 0x01			;clear display
	rcall	lcd_command
	inc	sensors				;next sensor
	cpi	sensors, 20
	brcs	_mai1
	ldi	sensors, 0
_mai1:	rjmp	display_temp_inline
display_temp_ret:
_mai2:	sbrs	flags, second1
	rjmp	main
	cbr	flags, 1<<second1^1<<convert
	dec	meas_delay
	brne	main
	ldi	meas_delay, 2			;10 seconds
	sbr	flags, 1<<convert
	rcall	start_measure
	rjmp	main
;-------------------------------------------------------------------------
.include "disptemp.inc"
.include "outval.inc"
.include "lcd12s.inc"
.include "1wire.inc"
;-------------------------------------------------------------------------
.include "calc12_3.inc"
;-------------------------------------------------------------------------
